#include <stdio.h>
//changed by lizhang
#ifdef LINUX
#include <values.h>
#endif
#ifdef WIN32
#include <float.h>
#endif
//end of change
#include "DepthMap.h"
#include "defines.h"

DepthMap::DepthMap()
{
    this->xdim = this->ydim = 0;
    this->elems = NULL;
}


DepthMap::DepthMap(int xd, int yd)
{
   this->xdim = xd;
   this->ydim = yd;
   
   this->elems = new DepthElement[xd*yd];
   if (this->elems == NULL) {
      this->xdim = 0;
      this->ydim = 0;
      fprintf(stderr, "DepthMap::new - couldn't allocate memory\n");
   }
}


DepthMap::~DepthMap()
{
   if (this->elems != NULL) {
      delete [] this->elems;
      this->elems = NULL;
   }
}


RangeGrid *
DepthMap::buildRangeGrid()
{
   int i, xx, yy, count; 

   RangeGrid *rangeGrid = new RangeGrid;
   rangeGrid->nlg = ydim;
   rangeGrid->nlt = xdim;
   rangeGrid->indices = new int[xdim*ydim];

   rangeGrid->numSamples = 0;
   for (i = 0; i < xdim*ydim; i++) {
      if (elems[i].z > -MAXFLOAT) {
	 rangeGrid->numSamples++;
      }
   }
   
   rangeGrid->coords = new Vec3f[rangeGrid->numSamples];
   rangeGrid->confidence = new float[rangeGrid->numSamples];
   rangeGrid->hasConfidence = 1;

   Vec3f point, unPoint;
   count = 0;
   i = 0;
   for (yy = 0; yy < ydim; yy++) {
      for (xx = 0; xx < xdim; xx++) {
	 if (elems[i].z > -MAXFLOAT) {
	    rangeGrid->indices[i] = count;
	    rangeGrid->confidence[count] = elems[i].conf;
	    point.setValue(xx, yy, elems[i].z);
	    unPoint = proj->unproject(point);
	    rangeGrid->coords[count].setValue(unPoint);
	    /*
	    rangeGrid->coords[count].setValue
	       (xx*resolution+origin[0], yy*resolution+origin[1], 
		elems[i].z);
	    */
	    count++;
	 }
	 else {
	    rangeGrid->indices[i] = -1;
	 }
	 i++;
      }
   }

   return rangeGrid;
}

