#ifndef _RANGE_GRID_
#define _RANGE_GRID_

#include "defines.h"
#include "Linear.h"

typedef uchar vec3uc[3];

class RangeGrid {
  public:

   int nlg;		/* number of range columns (samples in x) */
   int nlt;		/* number of rows (samples in y) */
   int numSamples;      /* number of range samples */
   Vec3f viewDir;       /* primary viewing direction */
   
   Vec3f *coords;	/* the range samples */
   Vec3f *norms;        /* normals */
   float *confidence;   /* confidence */
   float *intensity;    /* intensity */
   vec3uc *matDiff;     /* color */
   int *indices;	/* row x col indices to the positions */
   int hasColor;        /* color information? */
   int hasIntensity;    /* intensity information? */
   int hasConfidence;   /* confidence information? */
   int hasNormals;      /* confidence information? */
   char **obj_info;   
   int num_obj_info;
   
   RangeGrid();
   ~RangeGrid();
   int readPly(char *filename);
   int writePly(char *filename);

   void applyXform(Matrix4f &mat);
};

#endif

