//changed by lizhang
#ifdef LINUX
#include <unistd.h>
#endif
#ifdef WIN32
#include <stdlib.h>
#endif
//end of change

#include <stdio.h>
#include <malloc.h>

//changed by lizhang
#ifdef LINUX
#include <sys/times.h>
#endif
#ifdef WIN32
#include <time.h>
#include <float.h>
#endif
//end of change

#include <sys/types.h>
#include <math.h>

#include "defines.h"
#include "Linear.h"
#include "DepthMap.h"
#include "Mesh.h"

#include "sl_export.H"
#include "sl_vertex.H"
#include "sl_texture.H"
#include "sl_framebuffer.H"

// Clear the depth map
void Clear(FB_IntensityBuffer *buffer, Real Z, Real I);


// Take a mesh and rasterize it into a depth map
void
softRender(DepthMap *depthMap, Mesh *mesh)
{
    Vertex *v0, *v1, *v2;
    float x1, y1, x2, y2, crossz;
    IS_Vertex_ZI vzi0, vzi1, vzi2;
    FB_IntensityBuffer zbuffer;

    zbuffer.width = depthMap->xdim;
    zbuffer.height = depthMap->ydim;
    zbuffer.sampleZI = (FB_SampleZI *)depthMap->elems;
    Clear(&zbuffer, -MAXFLOAT, 0.0f);

    Triangle *tri = mesh->tris;
    for (int j = 0; j < mesh->numTris; j++, tri++) {
	v0 = mesh->verts + tri->vindex1;
	v1 = mesh->verts + tri->vindex2;
	v2 = mesh->verts + tri->vindex3;
	if (v0->coord.x < -0.5 || v0->coord.x > zbuffer.width-0.5 ||
	    v0->coord.y < -0.5 || v0->coord.y > zbuffer.height-0.5 ||
	    v1->coord.x < -0.5 || v1->coord.x > zbuffer.width-0.5 ||
	    v1->coord.y < -0.5 || v1->coord.y > zbuffer.height-0.5 ||
	    v2->coord.x < -0.5 || v2->coord.x > zbuffer.width-0.5 ||
	    v2->coord.y < -0.5 || v2->coord.y > zbuffer.height-0.5)
	    continue;

	x1 = v0->coord.x - v1->coord.x;
	y1 = v0->coord.y - v1->coord.y;

	x2 = v0->coord.x - v2->coord.x;
	y2 = v0->coord.y - v2->coord.y;

	crossz = x1*y2 - x2*y1;

	//	if (crossz < 0) {
	if (0) {
	    vzi0.I = -1;
	    vzi1.I = -1;
	    vzi2.I = -1;
	} else {
	    vzi0.I = v0->confidence;
	    vzi1.I = v1->confidence;
	    vzi2.I = v2->confidence;
	}

	vzi0.x = v0->coord.x;
	vzi0.y = v0->coord.y;
	vzi0.Z = v0->coord.z;

	vzi1.x = v1->coord.x;
	vzi1.y = v1->coord.y;
	vzi1.Z = v1->coord.z;

	vzi2.x = v2->coord.x;
	vzi2.y = v2->coord.y;
	vzi2.Z = v2->coord.z;

	SL_SCTriangle_DDA(&vzi0, &vzi1, &vzi2, 
			  (IS_CAttr_None *) NULL, &zbuffer);
    }
    for (int i = 0; i < zbuffer.width * zbuffer.height; i++) {
       if (zbuffer.sampleZI[i].I < 0) {
          zbuffer.sampleZI[i].Z = -MAXFLOAT;
          zbuffer.sampleZI[i].I = 0;
       }
    }
}


void
Clear(FB_IntensityBuffer *buffer, Real Z, Real I)
{
  for (int i = 0; i < buffer->width * buffer->height; i++) {
    buffer->sampleZI[i].Z = Z;
    buffer->sampleZI[i].I = I;
  }
}
